# -----------------------------------------------------------------------------
# Find DirectX SDK
# Define:
# DX11_FOUND
# GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER_SHARED
# GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER
# GTF_SCDR_DIRECTX11_INCLUDE_DIR
# GTF_SCDR_DIRECTX11_LIBRARY_D3D
# GTFSCDR_DIRECTX11_LIBRARY_DXGI
# GTFSCDR_DIRECTX11_LIBRARY_DXGUID

if(EB_PLATFORM_OS_WIN32) # The only platform it makes sense to check for DirectX SDK

    GET_FILENAME_COMPONENT(directXDirectory
        [HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\ Kits\\Installed\ Roots;KitsRoot81]
        ABSOLUTE)

    set(DirectX_search_paths_includes
        "${directXDirectory}/Include/shared"
        "${directXDirectory}/Include/um"
        $ENV{DXSDK_DIR}/Include)
    set(DirectX_search_paths_libraries
        "${directXDirectory}/Lib/winv6.3/um/${EB_PLATFORM_ARCH}"
        $ENV{DXSDK_DIR}/lib/x86)
    set(GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER_SHARED
        "${directXDirectory}/Redist/D3D/${EB_PLATFORM_ARCH}/d3dcompiler_47.dll")
        
    FIND_LIBRARY(GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER
      NAMES d3dcompiler
      HINTS
      ${DirectX_search_paths_libraries}
    )
    
    FIND_PATH(GTF_SCDR_DIRECTX11_INCLUDE_DIR D3D11.h D3DX11.h D3Dcompiler.h
      HINTS
      ${DirectX_search_paths_includes}
    )
    
    FIND_LIBRARY(GTF_SCDR_DIRECTX11_LIBRARY_D3D
      NAMES d3d11
      HINTS
      ${DirectX_search_paths_libraries}
    )
    
    FIND_LIBRARY(GTFSCDR_DIRECTX11_LIBRARY_DXGI
      NAMES dxgi
      HINTS
      ${DirectX_search_paths_libraries}
    )
    
    FIND_LIBRARY(GTFSCDR_DIRECTX11_LIBRARY_DXGUID
      NAMES dxguid
      HINTS
      ${DirectX_search_paths_libraries}
    )

    # handle the QUIETLY and REQUIRED arguments and set WGET_FOUND to TRUE if
    # all listed variables are TRUE
    INCLUDE(FindPackageHandleStandardArgs)
    FIND_PACKAGE_HANDLE_STANDARD_ARGS(
        DX11 DEFAULT_MSG
        GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER_SHARED
        GTF_SCDR_SDK8_LIBRARY_D3DCOMPILER
        GTF_SCDR_DIRECTX11_INCLUDE_DIR
        GTF_SCDR_DIRECTX11_LIBRARY_D3D
        GTFSCDR_DIRECTX11_LIBRARY_DXGUID
        GTFSCDR_DIRECTX11_LIBRARY_DXGI
        )

endif(EB_PLATFORM_OS_WIN32)
